commit 6f7f90113bc78440a248bef4b917583fde3e6e5f
Author: Jason Merrill <jason@redhat.com>
Date:   Thu Mar 16 13:11:32 2023 -0400

    c++: &enum::enumerator [PR101869]
    
    We don't want to call build_offset_ref with an enum.
    
            PR c++/101869
    
    gcc/cp/ChangeLog:
    
            * semantics.c (finish_qualified_id_expr): Don't try to build a
            pointer-to-member if the scope is an enumeration.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp0x/enum43.C: New test.

diff --git a/gcc/cp/semantics.c b/gcc/cp/semantics.c
index d846a1bd8f0..568f019fede 100644
--- a/gcc/cp/semantics.c
+++ b/gcc/cp/semantics.c
@@ -2143,7 +2143,8 @@ finish_qualified_id_expr (tree qualifying_class,
 
   /* If EXPR occurs as the operand of '&', use special handling that
      permits a pointer-to-member.  */
-  if (address_p && done)
+  if (address_p && done
+      && TREE_CODE (qualifying_class) != ENUMERAL_TYPE)
     {
       if (TREE_CODE (expr) == SCOPE_REF)
 	expr = TREE_OPERAND (expr, 1);
diff --git a/gcc/testsuite/g++.dg/cpp0x/enum43.C b/gcc/testsuite/g++.dg/cpp0x/enum43.C
new file mode 100644
index 00000000000..b2cd9797a06
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp0x/enum43.C
@@ -0,0 +1,11 @@
+// PR c++/101869
+
+enum E { A };
+E operator & (E e)
+{
+  return e;
+}
+E f(void)
+{
+    return &E::A;	 // { dg-error "not a class" "" { target c++98_only } }
+}

